Fast-update in self-learning algorithm for continuous-time quantum Monte Carlo
Abstract
We propose a novel technique for speeding up the self-learning Monte Carlo method applied to the single-site impurity model. For the case where the effective Hamiltonian is expressed by polynomial functions of differences of imaginary-time coordinate between vertices, we can remove the dependence of CPU time on the number of vertices, , by saving and updating some coefficients for each insertion and deletion process. As a result, the total cost for a single-step update is drastically reduced from to with being the order of polynomials in the effective Hamiltonian. Even for the existing algorithms, in which the absolute value is used instead of the difference as the variable of polynomial functions, we can limit the CPU time for a single step of Monte Carlo update to with the help of balanced binary search trees. We demonstrate that our proposed algorithm with only logarithmic -dependence achieves an exponential speedup from the existing methods, which suffer from severe performance issues at low temperatures.
I Introduction
Quantum Monte Carlo has been proved as one of the most powerful numerical methods on quantum many-body systems [1, 2]. It has already become a large family of algorithms, but one of the common problems among these methods is the CPU time efficiency. Although all Monte Carlo algorithms can give the exact measurement of any observables in the infinite Monte Carlo step limit, the statistical error is proportional to with being the Monte Carlo steps. This property means that any speedup on Monte Carlo algorithms will automatically make a significant difference in its performance.
Here, we focus on a continuous-time quantum Monte Carlo algorithm [3, 4, 5, 6], especially on its application to the single-impurity Anderson model [7]. The model describes the interaction between fermions at a local impurity and the bath, formed by a set of modes of the pure system. The Hamiltonian consists of non-interacting and interacting terms that can be written as [6]
(1) | ||||
(2) | ||||
(3) |
where () are the number operators of local fermions, are the fermion operators for the bath, is the chemical potential, denotes the on-site Coulomb repulsion at the impurity site, and gives the hybridization between the impurity and the bath. The parameter is an arbitrary positive constant of . One of the state-of-the-art algorithms on this model is the continuous-time auxiliary-field method (CT-AUX) [3, 4, 5], in which we introduce an auxiliary field for the interaction between upward and downward spin modes of the local impurity and rewrite as [8, 6, 9, 10]
(4) |
where . Then, we can make a simulation by sampling over the spin vertices inserted into the imaginary-time axis. Namely, the configuration will be , a set of spin vertices with their imaginary-time coordinates of auxiliary field. We can use various techniques to update the configuration, but the simplest is to either insert a new vertex at some imaginary time or remove an existing vertex in the configuration.
To decide whether to accept or reject a proposal of a new configuration, despite what update technique has been used, we need to calculate the weight difference between the initial and final states in addition to the possibility of making such a proposal. Usually, the latter can be easily obtained. For example, in CT-AUX, if we consider the most straightforward update of insertion or removal of a single vertex , the possibility of a proposal of removing an existing vertex is proportional to , where is the number of vertices, and insertion on a given imaginary-time point will cause a factor proportional to the length of the imaginary-time axis, namely, the inverse temperature . As for the weight, for a single configuration, it can be calculated by evaluating a determinant of a square matrix of size [6, 5]. As a result, the simplest brute-force Monte Carlo update will cost CPU time to calculate the weight. Fortunately, as the update of the configuration will only change the matrix of which we want to calculate the determinant locally, a fast-update technique can be applied to the Monte Carlo algorithm, and we can reduce the time complexity to for each step [11]. Still, calculating the weight is quite demanding computationally at low temperatures, as the average number of vertices increases in proportional to .
Recently, the self-learning Monte Carlo (SLMC) technique [12, 13, 14] has been considered to be applied to CT-AUX [8, 15]. In this new method, an effective Hamiltonian is used for single update steps, the parameters of which are learned from the original Hamiltonian. Instead of the cost for calculating the weight difference of the original Hamiltonian, we should find an effective Hamiltonian where the weight can be calculated much more efficiently. We run a number of Monte Carlo steps with the effective Hamiltonian to propose a configuration and finally return to the original Hamiltonian to decide whether to accept or reject it, to retain the detailed balance condition.
One proposal [8] of the effective Hamiltonian is to prepare such a Hamiltonian by training a linear regression model with simulation data. The effective Hamiltonian can be written as
(5) |
Here, and are linear combinations of Chebyshev polynomials of the absolute values of the imaginary time difference, coefficients of which can be trained with a set of with weight calculated exactly by the original Hamiltonian, namely using the fast-update of CT-AUX. is a function only depends on the number of vertices in the configuration and is also trained in a Chebyshev form. Note that we assume that the imaginary time is normalized as so that fits the interval . Orders of each term are fixed in advance to some small numbers. For example, the orders are for and , and for in [8]. Hereafter, we will use instead of , , and for simplicity, unless we need to distinguish between them.
Using the effective Hamiltonian, we can reduce the CPU time for a single Monte Carlo step down to . This cost is much smaller than the original method. After a number of Monte Carlo steps with the effective Hamiltonian, we calculate the weight with the original determinant algorithm (with CPU time of ) and then accept or reject the proposed configuration. Thus, the total time cost for a single step is , where is the length of updates with the effective Hamiltonian. Ideally, we choose as , the auto-correlation time of the original update, so we need to compare the complexity for the original Hamiltonian to generate one independent sample, with , where is the auto-correlation time for the new update, which should be small after a large number () of proposals with the effective Hamiltonian. If is long enough (), the speedup can be expressed as
(6) |
and will be a good speedup for large enough , or at low enough temperature, as well as is not so long [8].
In the present paper, we propose a new technique for calculating the weight difference of the effective Hamiltonian in Eq. (5). We will show that the CPU time complexity for a single step can be reduced to , compared with of the original SLMC update. Our method gives the same weight as the SLMC algorithm, but the -dependence of the CPU time complexity has been reduced to logarithmic. So we can expect an exponential speedup, especially at low temperature, where severe efficiency issues have been reported [16].
We should also notice that this form of effective Hamiltonian is free from the detailed structure of the models we are considering, and it fits for any cases where we can write the configuration by a set of of local degrees of freedom and imaginary times. So the technique introduced below should be helpful for other models as well, e.g., boson models.
II Moment pre-calculation technique
First, we consider the algorithm for the case where and are simply polynomials of , but not of its absolute value. The effective Hamiltonian used in [8] will be considered in the next section. At each Monte Carlo step, we insert a new vertex by randomly choosing an imaginary time and spin or remove a vertex from the configuration. Since we need to calculate the acceptance probability at each step, the weight of the proposed configuration needs to be calculated. Naively, it will cost CPU time for calculating the weight of any configuration , but we can do far more than this.
The most naive idea of acceleration is to consider the change of weight by the insertion or removal of a vertex [8]. For simplicity, we only consider the insertion, while for removal it is almost the same except for the sign. Suppose we already have a configuration with vertices (). Now we want to insert a new vertex at . For the part of the change will be
(7) |
Here, we ignore the overall factor , which can be included back at the end. As each term is an order- polynomial, the total CPU time for calculating is . (Note that although we train it as a linear combination of Chebyshev polynomials, we can combine them into one polynomial after obtaining all coefficients.) The part can be done almost the same, except for adding signs, and , for each term. As for , it can be pre-calculated up to some upper limit since the number of vertices is finite, and if exceeds the limit, we increase the upper limit to and calculate the values of the polynomial up to the new upper limit. Thus, after applying this technique, the total CPU time for one step becomes .
However, we can do more than this. Consider the structure of : it is a polynomial of , but it can be further expanded and regarded as a polynomial of with -dependent coefficients. If has the following form:
(8) |
then
(9) |
If we sum over all vertices of the term, it will be
(10) |
So, we can store the terms in the parenthesis in Eq. (10) as a vector of length . The contribution to the vector components from each is separable. This means that we can modify each component with cost of by performing the summation over for insertion or deletion of a vertex, and time for the update of all the components. If we have such a vector, the weight difference for inserting a vertex can be calculated by evaluating an order- polynomial, so the total CPU time cost for one step is .
Note that there is a trade-off in this moment pre-calculation method. Instead of storing the vector, if we rewrite Eq. (10) as
(11) |
we can save components of vectors (). In this case, each component can be updated in time for insertion and deletion, so the total cost for updating will be . However, we need to calculate components for each vector in the parenthesis for evaluating the weight difference. The CPU time for this part is , and thus the total CPU time will not change: we can choose whether to update faster and calculate the weight difference slower or use a faster calculation of weight difference and spend more time for updating the internal vector. In both cases, compared with the original update, our new method is free from the number of vertices . The price is a factor , which is fixed at the beginning and usually small (), so we can achieve a significant speedup.
One may notice that in Eq. (10), we have to evaluate the polynomial functions with fixed coefficients many times. This fact inspires us to do some pre-calculation for the polynomials. A naive idea is since our can only take values between and , pre-calculating the function values at points dividing evenly. Then, for a given , we find the interval including , and interpolate the function value at . This idea is, in fact, from the interpolation of Green’s function for the non-interacting system used in the CT-AUX method. After the pre-calculation, we can find the function value at any in time, and the total CPU time is thus reduced to .
The error from this interpolation is , where we have another trade-off between memory and error: the more data points we save, the less the error will be. Since at least we can easily save up to data points, we can expect the error under control, and this function is also compatible with the algorithm in the next section. However, we will stop here to consider approximate methods, and in the following, we will consider more rigorous evaluation methods.
III Solution for polynomials of absolute value of time difference
Instead of polynomial of , in the real simulation of fermion systems, a polynomial of is used [17, 18, 19, 20, 21] for (and also for ). This polynomial can be expanded to a polynomial of . The polynomial of can be further divided into two parts, each of which is even or odd with respect to . For the even part, since , no extra effort is needed. We can apply the technique presented in Sec II to calculate the weight difference when inserting or removing a vertex. So, we will focus on the odd part of the polynomial.
First, we consider the simplest case, where , so the problem is “calculating the total distance to all existing vertices from a given vertices at .” We know that
(12) |
This can be calculated in time, if we can maintain , (the number of which is smaller than ), and . The first quantity can be easily maintained, by adding or subtracting for each update, so the problem becomes how to deal with the second and the third quantities, related to that are smaller than a given .
Formally, we will need a data structure that can do:
-
1.
Insert a real number .
-
2.
Remove a real number , given its index.
-
3.
Given a real number , count the numbers in the data structure that is smaller than .
-
4.
Given a real number , count the sum of numbers in the data structure that is smaller than .
If takes some discrete values (e.g., integers) within some range, instead of real numbers, this is a standard application of the segment tree or the binary indexed tree [22]. We can use two binary indexed trees to maintain the number of smaller than and their sum.
Here, our problem is continuous, so we use another data structure called the balanced binary search tree [23]. As its name, the balanced binary search tree is a binary search tree of an ordered set of numbers (both discrete and continuous can be accepted). Among the family of binary search trees for a single data set, the balanced binary search tree is “balanced,” which means the difference of depth for a node’s left and right subtrees is very small. Suppose that we have a degenerating binary search tree, only a chain to the same side (e.g., to the left). Then, if we want to search for some value to see if it is inside the tree, using the binary search technique, we will need time to find it or decide that it is not in, where is the number of data items inside the data structure. However, if it is balanced, then the maximum depth is , so we can find any element in only time.
The balanced binary search tree (from here, we call it balanced tree for simplicity) is widely used in many standard libraries and applications. For example, in the STL of C++, implementation of template data structures (std::set and std::map) is, in fact, by a kind of balanced tree called the red-black tree [24, 25]. This kind of balanced tree is also used at many places in the kernel of Linux OS. Here in our task, if we can maintain an ordered data structure, finding accumulation properties for values smaller than some given value is expected to be more accessible. Thus, the balanced tree may be a good choice for our purpose.
Accumulative properties (for example, the sum of all ’s for a given range) is a natural sort of property to be maintained with binary or general rooted trees since each node can maintain the values of the subtree. However, what we are interested in here is the “lower part” of some node, namely, both of the subtree of its left child and the part above it if it is the right child of its parent. If for our accumulative property both of “add” and “subtract” operations are defined, the accumulative property for nodes “lower” than a given node can be calculated as: if the given node is the root or left child of its parent, then use the property saved in its left child, otherwise use the total accumulation property of the tree, subtracted by the value saved in its right child (and also subtracted by the value of the node itself if we are asking for a strict “lower” result).
However, a more natural solution can also work for properties that can only be added but cannot be subtracted. For example, the minimum value in the lower part of a given node can be “added” but not “subtracted.” We can maintain the minimum when merging a set of numbers with the minimum of the set, but when removing a subset, only the minimum in that set is not enough since we do not know whether this subset contains all the minimum values or not. In such a case, we can adopt a sort of random binary search tree called the splay tree [26]. Instead of strictly requiring the difference of depth for the two children for each node to be balanced, the splay tree uses a more interesting technique called “splay” operation, which performs to “rotate” a node to the root while potentially reducing the imbalance with keeping the binary search tree structure. Note that the properties of subtrees can be maintained under rotation (or splay) as long as the properties support addition. The splay operation can be done only in time. It is proved that this technique can make the complexity for operations on a balanced tree (insertion, deletion, queries for the rank of some value and -th value, and so on) be in average. As we have seen above, if the node we are considering is the root, then the lower part corresponds to the left subtree, so we can obtain the property lower than some value by first rotating (or “splaying”) the node to the root, then taking the value of its left child. The average time complexity of the whole operation is . Thus, we see that a balanced tree, or more naturally, a splay tree, can satisfy our four requirements for the data structure and solve the problem with time complexity for both updates and queries.
Now consider a more complex case, i.e., :
(13) |
For the first term, we need to store for , and then any query and update can be done in time. For the second term, we can expand it and maintain () in the spray tree, so that the difference can still be efficiently calculated.
From the previous “trade-off” discussion, we know that if we do not have the balanced tree part, we can either store the coefficients of (the complexity for the update is and for the query is ) or (the complexity for the update is , but to calculate the weight difference we need time). Here in the balanced tree part, we will have an extra factor, but we can reduce the total complexity by saving : we only need to maintain properties in the balanced tree, so the update and query for this part are . Thus, the total CPU time for one step (both update and query) is , which is much smaller than .
IV Implementation and Benchmark
Finally, we provide a simple benchmark for the SLMC update speed on calculating the weight difference when inserting and removing a vertex (Fig. 1). For the implementation of the method described above, please check our GitHub repository [27]. The result is just as we expected: while the CPU time of the simple update proposed in [8] is proportional to the average number of vertices, our method proposed in the present paper can calculate the weight difference with the CPU time only weakly depends on . The default test for , , shows a over 10 times speedup compared with the original update.
The present benchmark result is consistent with our analysis of the asymptotic time complexity: although for small , the constant factor for the pre-calculation may dominate the CPU time, for large enough , the logarithmic dependence on of our algorithm achieves an exponential speedup compared with the original algorithm.
V Conclusion
By introducing moment pre-calculation techniques and the help of the splay tree for maintaining the prefix, we have constructed an algorithm that improves the time complexity of a single Monte Carlo step of original SLMC on the CT-AUX method for the single-impurity Anderson model from to . Our method gives the same weight as the original one. For polynomials without absolute values on variables, we also propose an interpolation method that can further improve the time complexity to with pre-calculation of some polynomial functions. However, we need to consider the error caused by the interpolation process more carefully.
Although our ideas came from the impurity model and the SLMC algorithm on fermion impurities, the technique itself only depends on more general requirements. As long as the effective Hamiltonian is expressed as a sum of polynomial functions of distances over all pairs of vertices, we can always apply the present technique to obtain an exciting speedup. It gives a chance for more algorithms to use this idea to improve time complexity, so both save CPU time and improve the accuracy of measurements, which is the main issue, especially in Monte Carlo algorithms facing low-temperature physics. We are also looking forward to more discussions about applying the current technique and welcome further improvements based on this work.
Acknowlegements
The authors thank T. Kato, H. Suwa, and Y. Nagai for fruitful discussions and comments on algorithms and applications. R.C. was supported by the Global Science Graduate Course (GSGC) program of The University of Tokyo. This work was partially supported by JSPS KAKENHI (No. 17K05564 and 20H01824).
References
- Landau and Binder [2014] D. P. Landau and K. Binder, A Guide to Monte Carlo Simulations in Statistical Physics, 4th ed. (Cambridge University Press, Cambridge, 2014).
- Gubernatis et al. [2016] J. Gubernatis, N. Kawashima, and P. Werner, Quantum Monte Carlo Methods: Algorithms for Lattice Models (Cambridge University Press, Cambridge, 2016).
- Rombouts et al. [1998] S. Rombouts, K. Heyde, and N. Jachowicz, A discrete Hubbard-Stratonovich decomposition for general, fermionic two-body interactions, Phys. Lett. A 242, 271 (1998).
- Rombouts et al. [1999] S. Rombouts, K. Heyde, and N. Jachowicz, Quantum Monte Carlo method for fermions, free of discretization errors, Phys. Rev. Lett. 82, 4155 (1999).
- Gull et al. [2008] E. Gull, P. Werner, O. Parcollet, and M. Troyer, Continuous-time auxiliary-field Monte Carlo for quantum impurity models, Euro. Phys. Lett. 82, 57003 (2008).
- Gull et al. [2011a] E. Gull, A. J. Millis, A. I. Lichtenstein, A. N. Rubtsov, M. Troyer, and P. Werner, Continuous-time Monte Carlo methods for quantum impurity models, Rev. Mod. Phys. 83, 349 (2011a).
- Anderson [1961] P. W. Anderson, Localized magnetic states in metals, Phys. Rev. 124, 41 (1961).
- Nagai et al. [2017] Y. Nagai, H. Shen, Y. Qi, J. Liu, and L. Fu, Self-learning Monte Carlo method: Continuous-time algorithm, Phys. Rev. B 96, 161102 (2017).
- Blankenbecler et al. [1981] R. Blankenbecler, D. J. Scalapino, and R. L. Sugar, Monte Carlo calculations of coupled boson-fermion systems. I, Phys. Rev. D 24, 2278 (1981).
- Hirsch and Fye [1986] J. E. Hirsch and R. M. Fye, Monte Carlo method for magnetic impurities in metals, Phys. Rev. Lett. 56, 2521 (1986).
- Gull et al. [2011b] E. Gull, P. Staar, S. Fuchs, P. Nukala, M. S. Summers, T. Pruschke, T. C. Schulthess, and T. Maier, Submatrix updates for the continuous-time auxiliary-field algorithm, Phys. Rev. B 83, 075122 (2011b).
- Liu et al. [2017a] J. Liu, Y. Qi, Z. Y. Meng, and L. Fu, Self-learning Monte Carlo method, Phys. Rev. B 95, 041101 (2017a).
- Liu et al. [2017b] J. Liu, H. Shen, Y. Qi, Z. Y. Meng, and L. Fu, Self-learning Monte Carlo method and cumulative update in fermion systems, Phys. Rev. B 95, 241104 (2017b).
- Xu et al. [2017] X. Y. Xu, Y. Qi, J. Liu, L. Fu, and Z. Y. Meng, Self-learning quantum Monte Carlo method in interacting fermion systems, Phys. Rev. B 96, 041119(R) (2017).
- Nagai et al. [2020] Y. Nagai, M. Okumura, and A. Tanaka, Self-learning Monte Carlo method with Behler-Parrinello neural networks, Phys. Rev. B 101, 115111 (2020).
- Yamamoto et al. [2018] T. Yamamoto, M. Kato, T. Kato, and K. Saito, Heat transport via a local two-state system near thermal equilibrium, New J. Phys. 20, 093014 (2018).
- Wolf et al. [2014] F. A. Wolf, I. P. McCulloch, O. Parcollet, and U. Schollwöck, Chebyshev matrix product state impurity solver for dynamical mean-field theory, Phys. Rev. B 90, 115124 (2014).
- Braun and Schmitteckert [2014] A. Braun and P. Schmitteckert, Numerical evaluation of Green’s functions based on the Chebyshev expansion, Phys. Rev. B 90, 165112 (2014).
- Covaci et al. [2010] L. Covaci, F. Peeters, and M. Berciu, Efficient numerical approach to inhomogeneous superconductivity: the Chebyshev-Bogoliubov-de Gennes method, Phys. Rev. Lett. 105, 167006 (2010).
- Nagai et al. [2012] Y. Nagai, Y. Ota, and M. Machida, Efficient numerical self-consistent mean-field approach for fermionic many-body systems by polynomial expansion on spectral density, J. Phys. Soc. Japan 81, 024710 (2012).
- Sota and Tohyama [2008] S. Sota and T. Tohyama, Low-temperature density matrix renormalization group using regulated polynomial expansion, Phys. Rev. B 78, 113101 (2008).
- Fenwick [1994] P. M. Fenwick, A new data structure for cumulative frequency tables, Software Pract. Exper. 24, 327 (1994).
- Knuth [1973] D. Knuth, The Art Of Computer Programming, vol. 3: Sorting And Searching (Addison-Wesley, 1973).
- Bayer [1972] R. Bayer, Symmetric binary b-trees: Data structure and maintenance algorithms, Acta Informatica 1, 290 (1972).
- Guibas and Sedgewick [1978] L. J. Guibas and R. Sedgewick, A dichromatic framework for balanced trees, in 19th Annual Symposium on Foundations of Computer Science (sfcs 1978) (IEEE, 1978) pp. 8–21.
- Sleator and Tarjan [1985] D. D. Sleator and R. E. Tarjan, Self-adjusting binary search trees, J. ACM 32, 652 (1985).
- [27] https://github.com/CaoRX/SLMC-demo.